#!/bin/bash
# dhclient-script for GNU/kFreeBSD. Aurelien Jarno, May, 2005.
# Based on Linux and FreeBSD scripts.

make_resolv_conf() {
    if [ -n "$new_domain_name" -o -n "$new_domain_name_servers" ]; then
        local new_resolv_conf=/etc/resolv.conf.dhclient-new
        rm -f $new_resolv_conf
        if [ -n "$new_domain_name" ]; then
            echo domain ${new_domain_name%% *} >>$new_resolv_conf
        fi
	if [ -n "$new_domain_search" ]; then
		new_domain_search="${new_domain_search% }"
	    if [ -n "$new_domain_name" ]; then
	    	new_domain_search="$new_domain_name $new_domain_search"
	    fi
	    echo "search ${new_domain_search}" >> $new_resolv_conf
	elif [ -n "$new_domain_name" ]; then
		echo "search ${new_domain_name}" >> $new_resolv_conf
	fi
        if [ -n "$new_domain_name_servers" ]; then
                   for nameserver in $new_domain_name_servers; do
                       echo nameserver $nameserver >>$new_resolv_conf
            done
        else # keep 'old' nameservers
            sed -n /^\w*[Nn][Aa][Mm][Ee][Ss][Ee][Rr][Vv][Ee][Rr]/p /etc/resolv.conf >>$new_resolv_conf
        fi
        chown --reference=/etc/resolv.conf $new_resolv_conf
        chmod --reference=/etc/resolv.conf $new_resolv_conf
        mv -f $new_resolv_conf /etc/resolv.conf
    fi
}

run_hook() {
    local script="$1"
    local exit_status
    shift	# discard the first argument, then the rest are the script's

    if [ -f $script ]; then
        . $script "$@"
    fi


    if [ -n "$exit_status" ] && [ "$exit_status" -ne 0 ]; then
        logger -p daemon.err "$script returned non-zero exit status $exit_status"
        save_exit_status=$exit_status
    fi

    return $exit_status
}

run_hookdir() {
    local dir="$1"
    local exit_status
    shift	# See run_hook

    if [ -d "$dir" ]; then
        for script in $(run-parts --list $dir); do
            run_hook $script "$@" || true
            exit_status=$?
        done
    fi

    return $exit_status
}

# Must be used on exit.   Invokes the local dhcp client exit hooks, if any.
exit_with_hooks() {
    exit_status=$1

    # Source the documented exit-hook script, if it exists
    if ! run_hook /etc/dhcp/dhclient-exit-hooks "$@"; then
        exit_status=$?
    fi

    # Now run scripts in the Debian-specific directory.
    if ! run_hookdir /etc/dhcp/dhclient-exit-hooks.d "$@"; then
        exit_status=$?
    fi

    exit $exit_status
}

if [ -n "$new_broadcast_address" ]; then
    new_broadcast_arg="broadcast $new_broadcast_address"
fi
if [ -n "$old_broadcast_address" ]; then
    old_broadcast_arg="broadcast $old_broadcast_address"
fi
if [ -n "$new_subnet_mask" ]; then
    new_subnet_arg="netmask $new_subnet_mask"
fi
if [ -n "$old_subnet_mask" ]; then
    old_subnet_arg="netmask $old_subnet_mask"
fi
if [ -n "$alias_subnet_mask" ]; then
    alias_subnet_arg="netmask $alias_subnet_mask"
fi
if [ -n "$new_interface_mtu" ] && [ $new_interface_mtu -ge 575 ]; then
    mtu_arg="mtu $new_interface_mtu"
fi
if [ -n "$IF_METRIC" ]; then
    metric_arg="metric $IF_METRIC"	# interfaces(5), "metric" option
fi


# The action starts here

# Invoke the local dhcp client enter hooks, if they exist.
run_hook /etc/dhcp/dhclient-enter-hooks
run_hookdir /etc/dhcp/dhclient-enter-hooks.d

# Execute the operation
case "$reason" in
    MEDIUM|ARPCHECK|ARPSEND)
        # Do nothing
        ;;
    PREINIT)
        # The DHCP client is requesting that an interface be
        # configured as required in order to send packets prior to
        # receiving an actual address. - dhclient-script(8)

        if [ -n "$alias_ip_address" ]; then
            ifconfig $interface inet -alias $alias_ip_address > /dev/null 2>&1
            route delete $alias_ip_address 127.0.0.1 > /dev/null 2>&1
        fi
        ifconfig $interface inet 0.0.0.0 netmask 0.0.0.0 \
            broadcast 255.255.255.255 up
        ;;
    BOUND|RENEW|REBIND|REBOOT)

	if [ -n "$old_host_name" -a -n "$host_name" -a \
     	     "$host_name" != "$old_host_name" ]; then
    	    hostname "$new_host_name"
	fi

        if [ -n "$old_ip_address" -a -n "$alias_ip_address" -a \
             "$alias_ip_address" != "$old_ip_address" ]; then
            # Possible new alias. Remove old alias.
            ifconfig $interface inet -alias $alias_ip_address > /dev/null 2>&1
            route delete $alias_ip_address 127.0.0.1 > /dev/null 2>&1
        fi
        if [ -n "$old_ip_address" -a \
             "$old_ip_address" != "$new_ip_address" ]; then
            ifconfig $interface inet -alias $old_ip_address $medium
            route delete $old_ip_address 127.1 >/dev/null 2>&1
            # IP address changed. Bringing down the interface will delete all other
            # route, and clear the ARP cache.
            ifconfig $interface inet 0 down
        fi

	# point to point
	if [ "$new_subnet_mask" == "255.255.255.255" ]; then
		for router in $new_routers; do
	    	    route add $router $new_ip_address
		done
	fi

        if [ -z "$old_ip_address" -o "$old_ip_address" != "$new_ip_address" -o \
            "$reason" = "BOUND" -o "$reason" = "REBOOT" ]; then

            ifconfig $interface inet $new_ip_address $new_subnet_arg \
                $new_broadcast_arg $medium $mtu_arg
            route add $new_ip_address 127.1 $metric_arg >/dev/null 2>&1
            for router in $new_routers; do
                route add default $router >/dev/null 2>&1
            done
            if [ -n "$new_static_routes" ]; then
                set -- $new_static_routes
                while [ $# -gt 1 ]; do
                    route add $1 $2
                    shift; shift
                done
            fi
        fi

        if [ "$new_ip_address" != "$alias_ip_address" -a -n "$alias_ip_address" ];
            then
            ifconfig $interface inet alias $alias_ip_address $alias_subnet_arg
            route add $alias_ip_address 127.0.0.1
        fi

        make_resolv_conf

        ;;

    EXPIRE|FAIL|RELEASE|STOP)
        if [ -n "$alias_ip_address" ]; then
            # Turn off alias interface.
            ifconfig $interface inet -alias $alias_ip_address > /dev/null 2>&1
            route delete $alias_ip_address 127.0.0.1 > /dev/null 2>&1
        fi

        if [ -n "$old_ip_address" ]; then
            ifconfig $interface inet -alias $old_ip_address $medium
            route delete $old_ip_address 127.1 >/dev/null 2>&1
            # Shut down interface, which will delete all other routes and clear arp cache.
            ifconfig $interface inet 0 down
        fi

        if [ -n "$alias_ip_address" ]; then
            ifconfig $interface inet alias $alias_ip_address $alias_subnet_arg
            route add $alias_ip_address 127.0.0.1
        fi

        ;;
	
    TIMEOUT)
        if [ -n "$alias_ip_address" ]; then
            ifconfig $interface inet -alias $alias_ip_address > /dev/null 2>&1
            route delete $alias_ip_address 127.0.0.1 > /dev/null 2>&1
        fi

        ifconfig $interface inet $new_ip_address $new_subnet_arg \
            $new_broadcast_arg $medium $mtu_arg

        set -- $new_routers
        first_router="$1"

        if [ -z "$first_router" ] || ping -q -c 1 $first_router; then
            if [ "$new_ip_address" != "$alias_ip_address" -a \
                -n "$alias_ip_address" ]; then
	        ifconfig $interface inet alias $alias_ip_address $alias_subnet_arg
	        route add $alias_ip_address 127.0.0.1
            fi
	    route add $new_ip_address 127.1 >/dev/null 2>&1
	    
            for router in $new_routers; do
                route add default $router $metric_arg
            done
            set -- $new_static_routes
            while [ $# -gt 1 ]; do
                route add $1 $2
                shift; shift
            done

            make_resolv_conf
        else
            # Changed from 'ifconfig $interface inet 0 down' - see Debian bug #144666
            ifconfig $interface inet 0
            exit_with_hooks 2 "$@"
        fi

        ;;
esac

exit_with_hooks 0
